//New Title Atlas Adder
Scene_OmoriTitleScreen.prototype.createBackground = function() {
	// Create Background Sprite
	this._backgroundSprite = new TilingSprite();
	this._backgroundSprite.move(0, 0, Graphics.width, Graphics.height);
  this.addChild(this._backgroundSprite);
  if(this._worldType === 448 || this._worldType === 447 || this._worldType === 449 || this._worldType === 783) {this._backgroundSprite.bitmap =   ImageManager.loadParallax('!polaroidBG_FA_day');} 
  else if(this._worldType === 446) {
		var bitmap = new Bitmap(Graphics.width, Graphics.height);
		bitmap.fillAll('rgba(255, 255, 255, 1)');
		this._backgroundSprite.bitmap = bitmap;    
  }
  else if(this._worldType === 445) {// Red Space
    this._backgroundSprite.bitmap = ImageManager.loadParallax('!parallax_black_space');
  }
  else if(this._worldType === 444) {
		var bitmap = new Bitmap(Graphics.width, Graphics.height);
		bitmap.fillAll('rgba(0, 0, 0, 1)');
		this._backgroundSprite.bitmap = bitmap;    
  }
  else if(this._worldType === 781) {
    this._backgroundSprite.bitmap = ImageManager.loadParallax('!parallax_reflect'); 
  }
  else if(this._worldType === 782) {
    this._backgroundSprite.bitmap = ImageManager.loadParallax('!BS_cloud_parallax'); 
  }
  else if(this._worldType === 783) {
    this._backgroundSprite.bitmap = ImageManager.loadParallax('!polaroidBG_FA_day'); 
  }
  else if(this._worldType === 0) {
		var bitmap = new Bitmap(Graphics.width, Graphics.height);
		bitmap.fillAll('rgba(255, 255, 255, 1)');
		this._backgroundSprite.bitmap = bitmap;    
  }
};

Scene_OmoriTitleScreen.prototype.updateWorldBitmaps = function(world = this._worldType, temp = false) {
  // Set Title Bitmap
  var titleTextBitmap = 'OMO_TITLE_WS';
  var lightbulbBitmap = 'OMO_BULB_WS';
  var stringBitmap = 'OMO_STRING_WS';
  var omoriBitmap = 'OMO_WS';
  var linesBitmap = 'OMO_BULB_WS_LINES';
  // Set World
  switch (world) {
	case 0: // White space
		break;
	case 446: // White space
		break;
	case 2: // Faraway
		omoriBitmap = 'OMO_RS'
		titleTextBitmap = 'OMO_TITLE_BS';
		lightbulbBitmap = 'OMO_BULB_BS';
		stringBitmap =  'OMO_STRING_BS';
		linesBitmap = 'OMO_BULB_BS_LINES';
    break;
  case 3: // Red Space Omori
    titleTextBitmap = 'OMO_TITLE_BS';
    lightbulbBitmap = 'OMO_BULB_BS';
    stringBitmap = 'OMO_STRING_BS';
    omoriBitmap = 'OMO_WS';
    linesBitmap = 'OMO_BULB_BS_LINES';
    break;
	case 444: // Black space
		omoriBitmap = 'OMO_BS';
		titleTextBitmap = 'OMO_TITLE_BS';
		lightbulbBitmap = 'OMO_BULB_BS';
		stringBitmap =  'OMO_STRING_BS';
		linesBitmap = 'OMO_BULB_BS_LINES'
		break;
	case 445: // Red space
		omoriBitmap = 'OMO_RS';
		titleTextBitmap = 'OMO_TITLE_BS';
		lightbulbBitmap = 'OMO_BULB_BS';
		stringBitmap =  'OMO_STRING_BS';
		linesBitmap = 'OMO_BULB_BS_LINES'
    break;
  case 449:
	case 447: // Ending Good
		omoriBitmap = 'OMO_RS';
		titleTextBitmap = 'OMO_TITLE_WS';
		lightbulbBitmap = 'OMO_BULB_WS';
		stringBitmap =  'OMO_STRING_WS';
		linesBitmap = 'OMO_BULB_WS_LINES'
		break;
	case 448: // Ending Bad
		titleTextBitmap = 'OMO_TITLE_WS';
		lightbulbBitmap = 'OMO_BULB_WS';
		stringBitmap =  'OMO_STRING_WS';
		linesBitmap = 'OMO_BULB_WS_LINES'
		break;
  case 781:
    omoriBitmap = 'OMO_WS2';
    titleTextBitmap = 'OMO_TITLE_BS2';
    lightbulbBitmap = 'OMO_BULB_BS2';
    stringBitmap =  'OMO_STRING_BS2';
    linesBitmap = 'OMO_BULB_BS_LINES2';
	break;
  case 782:
    omoriBitmap = 'OMO_WS2';
    titleTextBitmap = 'OMO_TITLE_BS2';
    lightbulbBitmap = 'OMO_BULB_BS2';
    stringBitmap =  'OMO_STRING_BS2';
    linesBitmap = 'OMO_BULB_BS_LINES2';
	break;
  case 783:
    omoriBitmap = 'OMO_RS2';
    titleTextBitmap = 'OMO_TITLE_WS2';
    lightbulbBitmap = 'OMO_BULB_WS2';
    stringBitmap =  'OMO_STRING_WS2';
    linesBitmap = 'OMO_BULB_WS_LINES2';
  break;
	};
	if (temp) {
	//    titleTextBitmap = 'OMO_TITLE_BS';
	//    lightbulbBitmap = 'OMO_BULB_BS';
	//    stringBitmap =  'OMO_STRING_BS';
	//    linesBitmap = 'OMO_BULB_BS_LINES'
	}

  if (this._omoriSprite) this._omoriSprite.bitmap = ImageManager.loadPicture(omoriBitmap)
  this._titleTextSprite.bitmap = ImageManager.loadPicture(titleTextBitmap)
  this._lightBulbSprite.bitmap = ImageManager.loadPicture(lightbulbBitmap);
  this._lightBulbLinesSprite.bitmap = ImageManager.loadPicture(linesBitmap);
  // Set Omori Sprite Width & Height
  if (this._omoriSprite) this._omoriSprite.width = 306;
  if (this._omoriSprite) this._omoriSprite.height = 350;
  // Let Lines Width & Height
  this._lightBulbLinesSprite.width = 68;
  this._lightBulbLinesSprite.height =  150;
  // Get String Bitmap
  var string = ImageManager.loadPicture(stringBitmap);
  // Create Cable Bitmap
  var bitmap = this._lightbulbCableSprite.bitmap;
  bitmap.clear();
  bitmap.blt(string, 0, 0, string.width, string.height, 0, 0, string.width, 300);

};

Scene_OmoriTitleScreen.prototype.initAtlastLists = function() {
  // Super Call
  Scene_BaseEX.prototype.initAtlastLists.call(this);
  // Add Required Atlas
  if (this._worldType === 449 || this._worldType === 448 || this._worldType === 447 || this._worldType === 446 || this._worldType === 445 || this._worldType === 444|| this._worldType === 0) {
    this.addRequiredAtlas('Omori_TitleScreen')
  }
  else {
    this.addRequiredAtlas('Omori_TitleScreen2')
  }
  // Reserve Images
  ImageManager.reserveParallax('Black', 0, this._imageReservationId);
  ImageManager.reserveParallax('polaroidBG_BS_sky', 0, this._imageReservationId);
  ImageManager.reservePicture('Blackspace_polaroidBG_FA_day', 0, this._imageReservationId);
  // Load Input Icons
  ImageManager.loadInputIcons();
};

Scene_OmoriTitleScreen.prototype.initialize = function() {
  // Set Image reservation Id
  this._imageReservationId = 'title';
  // Super Call
  Scene_BaseEX.prototype.initialize.call(this);
  // Get Atlas Bitmap
  if (this._worldType === 449 || this._worldType === 448 || this._worldType === 447 || this._worldType === 446 || this._worldType === 445 || this._worldType === 444|| this._worldType === 0) {
    this._atlasBitmap = ImageManager.loadAtlas('Omori_TitleScreen');
  }
  else {
    this._atlasBitmap = ImageManager.loadAtlas('Omori_TitleScreen2');
  }
  // World Type 0: Normal, 1: Dark space, 2: Red Space
  let tryFile = DataManager.readFromFile("File");
  let tryTitleData = DataManager.readFromFile("TITLEDATA");
  if(!!tryTitleData) {this._worldType = parseInt(tryTitleData);}
  else if(!!tryFile) {this._worldType = parseInt(tryFile);}
  if(typeof this._worldType === "undefined") {this._worldType = 0;}
  if(![0,444,445,446,447,448,449,781,782,783].contains(this._worldType)) {this._worldType = 0;}
  // Set Command Active Flag
  this._commandActive = false;
  // Options Active Flag
  this._optionsActive = false;
  // Set Command Index Flag
  this._commandIndex = 0;
  // Instant Intro Flag
  this._instantIntro = false;
  // Determine if can continue
  this._canContinue = false;
  // Check if Save files exist
  for (var i = 1; i < 7; i++) {
    if (StorageManager.exists(i)) { this._canContinue = true; break; }
  };
  this._instantIntro = true;
};

Scene_OmoriTitleScreen.prototype.createOmoriSprite = function() {
  // Create Omori Sprite
	if (this._worldType != 448) {
		if (this._worldType === 0 || this._worldType === 446 || this._worldType === 782 || this._worldType === 781) {
			this._omoriSprite = new Sprite(ImageManager.loadPicture('OMO_WS'));
		} else if (this._worldType === 444) {
			this._omoriSprite = new Sprite(ImageManager.loadPicture('OMO_BS'));
		} else if (this._worldType === 445 || this._worldType === 447 || this._worldType === 449 || this._worldType === 783) {
      this._omoriSprite = new Sprite(ImageManager.loadPicture('OMO_RS'));
    }
		this._omoriSprite.anchor.set(0.5, 1)
		this._omoriSprite.x = Graphics.width / 2;
		this._omoriSprite.y = Graphics.height;
		this._omoriSprite.opacity = 0;
		this._omoriSprite.setFrame(0, 0, 0, 0);
		this._omoriSprite.filters = [this._glitchFilter];

		this._omoriSprite.visible = this._worldType !== 4;
		this._omoriSprite.filterArea = new PIXI.Rectangle(0, 0, Graphics.width, Graphics.height + Math.floor(Graphics.height / 6));
		this.addChild(this._omoriSprite);
	}
};

Scene_OmoriTitleScreen.prototype.createTitleSprites = function() {
  // Create Title Text Container Sprite
  this._titleTextContainerSprite = new Sprite()
  this._titleTextContainerSprite.x = 167;
  this._titleTextContainerSprite.y = 130;
  this._titleTextContainerSprite.opacity = 0
  this.addChild(this._titleTextContainerSprite);

  // Create Lightbulb Sprite
	if (this._worldType === 0 || this._worldType === 446 || this._worldType === 447 || this._worldType === 448 || this._worldType === 449 || this._worldType === 783) {
		this._lightBulbSprite = new Sprite(ImageManager.loadPicture('OMO_BULB_WS'));
	} else if (this._worldType === 444 || this._worldType === 445 || this._worldType === 781 || this._worldType === 782) {
		this._lightBulbSprite = new Sprite(ImageManager.loadPicture('OMO_BULB_BS'));
	}
  this._lightBulbSprite.x = 120;
  this._lightBulbSprite.y = -2;
  //this._lightBulbSprite.y = 18;
  // this._lightBulbSprite.setFrame(0, 0, 68, 150)
  this._titleTextContainerSprite.addChild(this._lightBulbSprite);

  // Create Lightbulb Sprite
	if (this._worldType === 0 || this._worldType === 446 || this._worldType === 447 || this._worldType === 448 || this._worldType === 449 || this._worldType === 783) {
		this._lightBulbLinesSprite = new Sprite(ImageManager.loadPicture('OMO_BULB_WS_LINES'));
	} else if (this._worldType === 444 || this._worldType === 445 || this._worldType === 781 || this._worldType === 782) {
		this._lightBulbLinesSprite = new Sprite(ImageManager.loadPicture('OMO_BULB_BS_LINES'));
	}
  this._lightBulbLinesSprite.x = 120;
  this._lightBulbLinesSprite.y = 0;
  this._lightBulbLinesSprite.opacity = 0;
  this._lightBulbLinesSprite.setFrame(0, 0, 68, 150)
  this._titleTextContainerSprite.addChild(this._lightBulbLinesSprite);
  // Get String Bitmap
	if (this._worldType === 0 || this._worldType === 446 || this._worldType === 447 || this._worldType === 448 || this._worldType === 449 || this._worldType === 783) {
		var string = ImageManager.loadPicture('OMO_STRING_WS');
	} else if (this._worldType === 444 || this._worldType === 445 || this._worldType === 781 || this._worldType === 782) {
		var string = ImageManager.loadPicture('OMO_STRING_BS');
	}
  // Create Cable Bitmap
  var bitmap = new Bitmap(68, 300);
  bitmap.blt(string, 0, 0, string.width, string.height, 0, 0, string.width, 300)

  // Create Lightbulb cable sprite
  this._lightbulbCableSprite = new Sprite(bitmap)
  this._lightbulbCableSprite.x = this._lightBulbSprite.x;
  this._lightbulbCableSprite.y = -282//-bitmap.height;
  this._titleTextContainerSprite.addChild(this._lightbulbCableSprite);

  // Create Title Text Sprite
	if (this._worldType === 0 || this._worldType === 446 || this._worldType === 447 || this._worldType === 448 || this._worldType === 449 || this._worldType === 783|| this._worldType === 781) {
		this._titleTextSprite = new Sprite(ImageManager.loadPicture('OMO_TITLE_WS'));
	} else if (this._worldType === 444 || this._worldType === 445  || this._worldType === 782) {
		this._titleTextSprite = new Sprite(ImageManager.loadPicture('OMO_TITLE_BS'));
	}
  this._titleTextSprite.opacity = 0;
  this._titleTextContainerSprite.addChild(this._titleTextSprite)
};

Scene_OmoriTitleScreen.prototype.playBgm = function () {
  var name ="user_title";
  /*switch (this._worldType) {
    case 1:
      name = "user_title";
      break;
    case 2:
      name = "user_title";
      break;
    case 3:
      name = "user_title";
      //name = "bs_56_12_2";
      break;
    default:
      name = "user_title";
      break;
  }*/
  if(this._worldType === 449 || this._worldType === 447) {name = "duet_mari"} 
  else if(this._worldType === 448) {name = "AMB_forest"} 
  else if(this._worldType === 446) {name ="user_title";}
  else if(this._worldType === 445) {// Red Space
    name = "bs_listening";
  }
  else if(this._worldType === 444) {
    name = "bs_listening";
  }
  else if(this._worldType === 781) {
    name = "bs_nawa";
  }
  else if(this._worldType === 782) {
    name = "am_hollow";
  }
  else if(this._worldType === 783) {
    name = "am_fat_cem2";
  }
  else {name ="user_title";}
  AudioManager.playBgm({name: name, volume: 100, pitch: 100});
};

// World Type/TITLEDATA Adder
Scene_OmoriFile.prototype.saveGame = function() {
  // On Before Save
  $gameSystem.onBeforeSave();
  // Get Save File ID
  var saveFileid = this.savefileId();
  // Get File Window
  var fileWindow = this._fileWindows[this._saveIndex];
  // Save Game
  this._promptWindow.deactivate();
  this._promptWindow.close();
  this._waitingWindow.show(); // Show Waiting Window;
  if (DataManager.saveGame(saveFileid)) {
  SoundManager.playSave();
  StorageManager.cleanBackup(saveFileid);
  var world;
  if ($gameSwitches.value(783)) {
      world = 783
  } else if ($gameSwitches.value(782)) {
      world = 782
  } else if ($gameSwitches.value(781)) {
      world = 781
  } else if($gameSwitches.value(448) && $gameSwitches.value(447)) {
      world = 449 // Special Flag When both the switches are on;
  } else if ($gameSwitches.value(448)) {
      world = 448;
  } else if ($gameSwitches.value(447)) {
      world = 447;
  } else if ($gameSwitches.value(446)) {
      world = 446;
  } else if ($gameSwitches.value(445)) {
      world = 445;
  } else if ($gameSwitches.value(444)) {
      world = 444;
  } else {
      world = 0
  }
  DataManager.writeToFileAsync(world, "TITLEDATA", () => {
      this.backupSaveFile(() => {
          fileWindow.refresh();
          // Deactivate Prompt Window
          this._waitingWindow.clear();
          // Set Can select Flag to false
          this._canSelect = true;
          // Update Save Index Cursor
          this.updateSaveIndexCursor();
      })
  });
  //   console.log(world); 
  } else {
  SoundManager.playBuzzer();
  // Deactivate Prompt Window
  this._promptWindow.deactivate();
  this._promptWindow.close();
  // Set Can select Flag to false
  this._canSelect = true;
  // Update Save Index Cursor
  this.updateSaveIndexCursor();
  };
}; // Thank you FoG